import { b7 as E, $ as t, b8 as m, P as L, w as P, S as F, e5 as k, O as g, a as A, bv as h, bG as I, bH as M, e8 as H, N, U as D, F as i, bc as a, G as b, bd as o, be as r, e9 as O, bb as c, dk as R, ea as $, bi as B, bj as U, eb as d, dY as W } from "./fae5a18b.js";
import { useContext as u, useEffect as _ } from "react";
import { treeCommonChildren as j, treeDataPropertyView as q, formSection as G, valuePropertyView as K, TreeNameConfigs as Y, useTree as z } from "./53d5d40f.js";
import { getStyle as J, baseSelectRefMethods as Q } from "./5bb3432e.js";
import { SelectInputValidationSection as X, useSelectInputValidate as Z } from "./357fb405.js";
import "react-dom";
import "./0fba2843.js";
import "./bd847912.js";
import "./32143a8e.js";
import "./98037d13.js";
const ee = E(d)`
  width: 100%;
  ${(e) => e.$style && J(e.$style)}
`, te = [{
  label: t("tree.singleSelect"),
  value: "single"
}, {
  label: t("tree.multiSelect"),
  value: "multi"
}, {
  label: t("tree.checkbox"),
  value: "check"
}], le = [{
  label: t("tree.showAll"),
  value: "all"
}, {
  label: t("tree.showParent"),
  value: "parent"
}, {
  label: t("tree.showChild"),
  value: "child"
}], ae = {
  ...j,
  selectType: m(te, "single"),
  checkedStrategy: m(le, "parent"),
  label: L,
  placeholder: P(F, t("tree.placeholder")),
  // TODO: more event
  onEvent: k,
  allowClear: g,
  showSearch: g.DEFAULT_TRUE,
  inputValue: A(""),
  // search value
  style: h(I),
  labelStyle: h(M),
  inputFieldStyle: h(H),
  viewRef: N
};
function oe(e) {
  switch (e) {
    case "all":
      return d.SHOW_ALL;
    case "parent":
      return d.SHOW_PARENT;
    case "child":
      return d.SHOW_CHILD;
  }
}
const re = (e) => {
  const {
    treeData: y,
    selectType: s,
    value: n,
    expanded: w,
    style: C,
    labelStyle: f,
    inputValue: V
  } = e, p = s === "single", [v, T] = Z(e);
  return _(() => {
    p && n.value.length > 1 && n.onChange(n.value.slice(0, 1));
  }, [s]), z(e), e.label({
    required: e.required,
    ...v,
    style: C,
    labelStyle: f,
    inputFieldStyle: e.inputFieldStyle,
    children: /* @__PURE__ */ i(ee, {
      ref: e.viewRef,
      $style: e.inputFieldStyle,
      popupMatchSelectWidth: !1,
      disabled: e.disabled,
      placeholder: e.placeholder,
      allowClear: e.allowClear,
      fieldNames: {
        label: "label",
        value: "value"
      },
      treeData: y,
      multiple: !p,
      value: p ? n.value[0] : n.value,
      treeCheckable: s === "check",
      showCheckedStrategy: oe(e.checkedStrategy),
      treeLine: e.showLine ? {
        showLeafIcon: e.showLeafIcon
      } : !1,
      treeExpandedKeys: V ? void 0 : w.value,
      onTreeExpand: (l) => {
        w.onChange(l);
      },
      onChange: (l) => {
        const x = Array.isArray(l) ? l : l !== void 0 ? [l] : [];
        T(x);
      },
      showSearch: e.showSearch,
      treeNodeFilterProp: "label",
      autoClearSearchValue: !1,
      onSearch: (l) => {
        e.dispatch(W("inputValue", l, !1));
      },
      onFocus: () => e.onEvent("focus"),
      onBlur: () => e.onEvent("blur")
    }, s)
  });
};
let S = function() {
  return new D(ae, (e, y) => /* @__PURE__ */ i(re, {
    ...e,
    dispatch: y
  })).setPropertyViewFn((e) => /* @__PURE__ */ a(b, {
    children: [/* @__PURE__ */ a(o, {
      name: r.basic,
      children: [q(e), O(e)]
    }), ["logic", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ a(b, {
      children: [/* @__PURE__ */ i(X, {
        ...e
      }), G(e), /* @__PURE__ */ a(o, {
        name: r.interaction,
        children: [e.onEvent.getPropertyView(), e.hidden.propertyView({
          label: t("prop.hide")
        }), e.disabled.propertyView({
          label: t("prop.disabled")
        }), e.selectType.propertyView({
          label: t("tree.selectType")
        }), K(e), e.selectType.getView() === "check" && e.checkedStrategy.propertyView({
          label: t("tree.checkedStrategy")
        }), R(e), $(e)]
      })]
    }), ["layout", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ a(o, {
      name: r.layout,
      children: [e.expanded.propertyView({
        label: t("tree.expanded")
      }), e.defaultExpandAll.propertyView({
        label: t("tree.defaultExpandAll")
      }), e.showLine.propertyView({
        label: t("tree.showLine")
      }), e.showLine.getView() && e.showLeafIcon.propertyView({
        label: t("tree.showLeafIcon")
      })]
    }), ["layout", "both"].includes(u(c).editorModeStatus) && e.label.getPropertyView(), ["layout", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ a(b, {
      children: [/* @__PURE__ */ i(o, {
        name: r.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ i(o, {
        name: r.labelStyle,
        children: e.labelStyle.getPropertyView()
      }), /* @__PURE__ */ i(o, {
        name: r.inputFieldStyle,
        children: e.inputFieldStyle.getPropertyView()
      })]
    })]
  })).setExposeMethodConfigs(Q).build();
}();
S = class extends S {
  autoHeight() {
    return !0;
  }
};
const Se = B(S, [...Y, new U("inputValue", t("select.inputValueDesc"))]);
export {
  Se as TreeSelectComp
};
