import { b7 as V, $ as t, b8 as E, O as w, w as T, P as F, e5 as P, bv as u, bG as L, bH as I, e6 as M, U as $, F as a, bc as s, G as b, bd as r, be as i, bb as c, bi as A, cr as B, e7 as D } from "./fae5a18b.js";
import { useContext as d, useState as H, useEffect as K } from "react";
import { treeCommonChildren as N, treeDataPropertyView as j, formSection as q, valuePropertyView as z, TreeNameConfigs as G, useTree as O } from "./53d5d40f.js";
import { SelectInputValidationSection as R, selectInputValidate as U } from "./357fb405.js";
import "react-dom";
import "./0fba2843.js";
import "./bd847912.js";
const J = V.div`
  height: 100%;
  padding: 4px;
  background: ${(e) => e.background};
  border: 1px solid ${(e) => e.border};
  border-radius: ${(e) => e.radius};
  .ant-tree-show-line .ant-tree-switcher {
    background: ${(e) => e.background};
  }
  .ant-tree:hover .ant-tree-list-scrollbar-show {
    display: block !important;
  }
  .ant-tree-list-scrollbar {
    width: 6px !important;
  }
  .ant-tree-list-scrollbar-thumb {
    border-radius: 9999px !important;
    background: rgba(139, 143, 163, 0.2) !important;
  }
  .ant-tree-list-scrollbar-thumb:hover {
    background: rgba(139, 143, 163, 0.5) !important;
  }
`, Q = [{
  label: t("tree.noSelect"),
  value: "none"
}, {
  label: t("tree.singleSelect"),
  value: "single"
}, {
  label: t("tree.multiSelect"),
  value: "multi"
}, {
  label: t("tree.checkbox"),
  value: "check"
}], W = {
  ...N,
  selectType: E(Q, "single"),
  checkStrictly: w,
  autoExpandParent: w,
  label: T(F, {
    position: "column"
  }),
  // TODO: more event
  onEvent: P,
  style: u(L),
  labelStyle: u(I.filter((e) => ["accent", "validate"].includes(e.name) === !1)),
  inputFieldStyle: u(M)
}, X = (e) => {
  const {
    treeData: S,
    selectType: o,
    value: l,
    expanded: y,
    checkStrictly: h,
    style: v,
    labelStyle: f
  } = e, [x, C] = H(), m = o === "single" || o === "multi", g = o === "check";
  return K(() => {
    o === "none" && l.value.length > 0 ? l.onChange([]) : o === "single" && l.value.length > 1 && l.onChange(l.value.slice(0, 1));
  }, [o]), O(e), e.label({
    required: e.required,
    ...U(e),
    style: v,
    labelStyle: f,
    inputFieldStyle: e.inputFieldStyle,
    children: /* @__PURE__ */ a(B, {
      onResize: (n, k) => C(k),
      render: () => /* @__PURE__ */ a(J, {
        ...e.inputFieldStyle,
        children: /* @__PURE__ */ a(D, {
          disabled: e.disabled,
          height: x,
          rootStyle: {
            background: "transparent",
            color: e.inputFieldStyle.text
          },
          fieldNames: {
            title: "label",
            key: "value"
          },
          treeData: S,
          selectable: m,
          multiple: o === "multi",
          selectedKeys: m ? l.value : [],
          checkable: g,
          checkedKeys: g ? h ? {
            checked: l.value,
            halfChecked: []
          } : l.value : void 0,
          checkStrictly: h,
          showLine: e.showLine ? {
            showLeafIcon: e.showLeafIcon
          } : !1,
          expandedKeys: y.value,
          autoExpandParent: e.autoExpandParent,
          onSelect: (n) => {
            l.onChange(n), e.onEvent("change");
          },
          onCheck: (n) => {
            l.onChange(Array.isArray(n) ? n : n.checked), e.onEvent("change");
          },
          onExpand: (n) => {
            y.onChange(n);
          },
          onFocus: () => e.onEvent("focus"),
          onBlur: () => e.onEvent("blur")
        }, o)
      })
    })
  });
};
let p = function() {
  return new $(W, (e) => /* @__PURE__ */ a(X, {
    ...e
  })).setPropertyViewFn((e) => /* @__PURE__ */ s(b, {
    children: [/* @__PURE__ */ a(r, {
      name: i.basic,
      children: j(e)
    }), ["logic", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ s(b, {
      children: [/* @__PURE__ */ a(R, {
        ...e
      }), q(e), /* @__PURE__ */ s(r, {
        name: i.interaction,
        children: [e.onEvent.getPropertyView(), e.hidden.propertyView({
          label: t("prop.hide")
        }), e.disabled.propertyView({
          label: t("prop.disabled")
        }), e.selectType.propertyView({
          label: t("tree.selectType")
        }), e.selectType.getView() !== "none" && z(e), e.selectType.getView() === "check" && e.checkStrictly.propertyView({
          label: t("tree.checkStrictly"),
          tooltip: t("tree.checkStrictlyTooltip")
        })]
      })]
    }), ["layout", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ s(r, {
      name: i.layout,
      children: [e.expanded.propertyView({
        label: t("tree.expanded")
      }), e.defaultExpandAll.propertyView({
        label: t("tree.defaultExpandAll")
      }), e.showLine.propertyView({
        label: t("tree.showLine")
      }), e.showLine.getView() && e.showLeafIcon.propertyView({
        label: t("tree.showLeafIcon")
      })]
    }), ["layout", "both"].includes(d(c).editorModeStatus) && e.label.getPropertyView(), ["layout", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ s(b, {
      children: [/* @__PURE__ */ a(r, {
        name: i.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ a(r, {
        name: i.labelStyle,
        children: e.labelStyle.getPropertyView()
      }), /* @__PURE__ */ a(r, {
        name: i.inputFieldStyle,
        children: e.inputFieldStyle.getPropertyView()
      })]
    })]
  })).build();
}();
p = class extends p {
  autoHeight() {
    return !1;
  }
};
const oe = A(p, G);
export {
  oe as TreeComp
};
