import { b7 as C, ch as P, c3 as E, c4 as I, $ as r, U as z, F as a, bb as s, cr as F, bc as l, G as b, bd as d, be as m, bf as D, bg as N, bh as M, bi as T, bj as j, bk as k, bl as L, w as f, S as $, b8 as W, co as U, b9 as A, ba as R, L as O, N as G, bm as q, bn as J, bo as K, bp as Q } from "./fae5a18b.js";
import { useState as S, useRef as V, useEffect as X, useContext as h } from "react";
import { Button100 as Y, ButtonStyleControl as Z } from "./7af150f0.js";
import "react-dom";
const _ = C.div`
  height: 100%;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  ${(t) => t.$style && tt(t.$style)}
`, tt = (t) => P`
    button {
      border: 1px solid ${t.border};
      border-radius: ${t.radius};
      margin: ${t.margin};
      padding: ${t.padding};
      max-width: ${E(t.margin)};
      max-height: ${I(t.margin)};
    }
  `, et = C(L)`
  font-size: 13px;
  margin-right: 4px;
`, nt = C.div`
  display: flex;

  ${(t) => t.$style && ot(t.$style)}
`;
function ot(t) {
  return P`
    svg {
      width: ${t.size} !important;
      height: ${t.size} !important;
    }
  `;
}
function it(t) {
  return t.uiCompInfoList().filter((e) => e.type === "form").map((e) => ({
    label: e.name,
    value: e.name
  }));
}
function w(t, e) {
  const n = t == null ? void 0 : t.getUICompByName(e);
  if (n && n.children.compType.getView() === "form")
    return n.children.comp;
}
function at(t, e) {
  const n = w(t, e);
  if (n)
    return /* @__PURE__ */ a(Q.Provider, {
      value: e,
      children: n.onEventPropertyView(/* @__PURE__ */ l(b, {
        children: [/* @__PURE__ */ a(et, {
          onClick: () => t.setSelectedCompNames(/* @__PURE__ */ new Set([e]), "rightPanel"),
          children: e
        }), r("button.formButtonEvent")]
      }))
    });
}
class rt extends q {
  getPropertyView() {
    const e = r("button.formToSubmit");
    return J({
      filterText: e
    }, /* @__PURE__ */ a(s.Consumer, {
      children: (n) => /* @__PURE__ */ l(b, {
        children: [/* @__PURE__ */ a(K, {
          label: e,
          value: this.value,
          options: it(n),
          onChange: (u) => this.dispatchChangeValueAction(u),
          allowClear: !0
        }), at(n, this.value)]
      })
    }));
  }
}
const lt = [{
  label: r("button.default"),
  value: ""
}, {
  label: r("button.submit"),
  value: "submit"
}];
function H(t) {
  return !t;
}
function st(t, e) {
  const n = w(t, e);
  n && n.submit();
}
const ct = {
  iconSize: f($, "20px"),
  type: W(lt, ""),
  autoHeight: f(U, "fixed"),
  aspectRatio: f($, "1 / 1"),
  onEvent: A,
  disabled: R,
  loading: R,
  form: rt,
  prefixIcon: O,
  style: Z,
  viewRef: G
};
let y = function() {
  return new z(ct, (t) => {
    const [e, n] = S(120), [u, ut] = S(0), g = V(null), p = V(null);
    X(() => {
      u && e && x();
    }, [u, e]);
    const B = (o, i) => {
      const c = g.current, v = c == null ? void 0 : c.getElementsByTagName("button")[0];
      c.style.height = o, c.style.width = i, v.style.height = o, v.style.width = i;
    }, x = () => {
      const o = g.current, i = p.current;
      !(o != null && o.clientWidth) || !(o != null && o.clientHeight) || t.autoHeight || !e || B((i == null ? void 0 : i.clientHeight) + "px", (i == null ? void 0 : i.clientWidth) + "px");
    };
    return /* @__PURE__ */ a(s.Consumer, {
      children: (o) => /* @__PURE__ */ a(F, {
        onResize: x,
        render: () => {
          var i;
          return /* @__PURE__ */ a(_, {
            ref: p,
            $style: t.style,
            children: /* @__PURE__ */ a("div", {
              ref: g,
              style: t.autoHeight ? {
                width: "100%",
                height: "100%"
              } : void 0,
              children: /* @__PURE__ */ a(Y, {
                ref: t.viewRef,
                $buttonStyle: t.style,
                loading: t.loading,
                style: t.autoHeight ? {
                  width: "100%",
                  height: "100%",
                  aspectRatio: t.aspectRatio,
                  borderRadius: t.style.radius
                } : {
                  aspectRatio: t.aspectRatio,
                  borderRadius: t.style.radius
                },
                disabled: t.disabled || !H(t.type) && ((i = w(o, t.form)) == null ? void 0 : i.disableSubmit()),
                onClick: () => H(t.type) ? t.onEvent("click") : st(o, t.form),
                children: t.prefixIcon && /* @__PURE__ */ a(nt, {
                  $style: {
                    ...t.style,
                    size: t.iconSize
                  },
                  children: t.prefixIcon
                })
              })
            })
          });
        }
      })
    });
  }).setPropertyViewFn((t) => /* @__PURE__ */ l(b, {
    children: [/* @__PURE__ */ a(d, {
      name: m.basic,
      children: t.prefixIcon.propertyView({
        label: r("button.icon")
      })
    }), (h(s).editorModeStatus === "logic" || h(s).editorModeStatus === "both") && /* @__PURE__ */ l(d, {
      name: m.interaction,
      children: [t.onEvent.getPropertyView(), D(t), N(t), M(t)]
    }), (h(s).editorModeStatus === "layout" || h(s).editorModeStatus === "both") && /* @__PURE__ */ l(b, {
      children: [/* @__PURE__ */ l(d, {
        name: m.layout,
        children: [t.autoHeight.getPropertyView(), t.iconSize.propertyView({
          label: r("button.iconSize")
        })]
      }), /* @__PURE__ */ l(d, {
        name: m.style,
        children: [t.style.getPropertyView(), t.aspectRatio.propertyView({
          label: r("style.aspectRatio")
        })]
      })]
    })]
  })).build();
}();
y = class extends y {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const gt = T(y, [new j("loading", r("button.loadingDesc")), ...k]);
export {
  gt as ControlButton
};
