import { ch as r, cD as h, b7 as b, cE as c, P as u, ba as x, cF as k, cG as f, bv as n, bG as s, bH as m, b8 as $, N as g, cH as p, U as v, F as i, bi as C, bj as S, $ as w, bk as B, cI as I, bu as F } from "./fae5a18b.js";
import { SelectInputValidationChildren as W, useSelectInputValidate as D, selectDivRefMethods as E, SelectInputInvalidConfig as R } from "./357fb405.js";
import { formDataChildren as V } from "./0fba2843.js";
import { RadioLayoutOptions as y, RadioPropertyView as z } from "./585b1d03.js";
import "react";
import { fixOldInputCompData as G } from "./f5a8aae2.js";
import "react-dom";
const O = (e) => r`
    &,
    .ant-checkbox-wrapper:not(.ant-checkbox-wrapper-disabled) {
      color: ${e.staticText};
      max-width: calc(100% - 8px);

      span:not(.ant-checkbox) {
        ${h};
      }

      .ant-checkbox-checked {
        .ant-checkbox-inner {
          background-color: ${e.checkedBackground};
          border-color: ${e.checkedBackground};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};

          &::after {
            border-color: ${e.checked};
          }
        }

        &::after {
          border-color: ${e.checkedBackground};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};
          border-radius: ${e.radius};
        }
      }
      
      .ant-checkbox-inner {
        border-radius: ${e.radius};
        background-color: ${e.uncheckedBackground};
        border-color: ${e.uncheckedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    
      &:hover .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#fff"};
      }

      &:hover .ant-checkbox-checked .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#ffff"};
      }

      &:hover .ant-checkbox-inner,
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input:focus + .ant-checkbox-inner {
        border-color: ${e.checkedBackground};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    }

    

    .ant-checkbox-group-item {
      font-family:${e.fontFamily};
      font-size:${e.textSize};
      font-weight:${e.textWeight};
      font-style:${e.fontStyle};
      text-transform:${e.textTransform};
      text-decoration:${e.textDecoration};
    }
    .ant-checkbox-wrapper {
      padding: ${e.padding};
      .ant-checkbox-inner,
      .ant-checkbox-checked::after {
        border-radius: ${e.radius};
      }
    }
  `, H = b(I)`
  min-height: 32px;
  ${(e) => e.$style && O(e.$style)}
  ${(e) => {
  if (e.$layout === "horizontal")
    return r`
        display: flex;
        align-items: center;
        flex-wrap: wrap;
      `;
  if (e.$layout === "vertical")
    return r`
        display: flex;
        flex-direction: column;
      `;
  if (e.$layout === "auto_columns")
    return r`
        break-inside: avoid;
        columns: 160px;
      `;
}}
`;
let t = function() {
  const e = {
    defaultValue: c("defaultValue"),
    value: c("value"),
    label: u,
    disabled: x,
    onEvent: k,
    options: f,
    style: n(s),
    labelStyle: n(m.filter((o) => ["accent", "validate"].includes(o.name) === !1)),
    layout: $(y, "horizontal"),
    viewRef: g,
    inputFieldStyle: n(p),
    ...W,
    ...V
  };
  return new v(e, (o) => {
    const [d, l] = D(o);
    return o.label({
      required: o.required,
      style: o.style,
      labelStyle: o.labelStyle,
      inputFieldStyle: o.inputFieldStyle,
      children: /* @__PURE__ */ i(H, {
        ref: o.viewRef,
        disabled: o.disabled,
        value: o.value.value,
        $style: o.inputFieldStyle,
        $layout: o.layout,
        options: o.options.filter((a) => a.value !== void 0 && !a.hidden).map((a) => ({
          label: a.label,
          value: a.value,
          disabled: a.disabled
        })),
        onChange: (a) => {
          l(a);
        }
      }),
      ...d
    });
  }).setPropertyViewFn((o) => /* @__PURE__ */ i(z, {
    ...o
  })).setExposeMethodConfigs(E).build();
}();
t = F(t, G);
const U = C(t, [new S("value", w("selectInput.valueDesc")), R, ...B]);
export {
  U as CheckboxComp,
  O as getStyle
};
